
package de.ivu.elect.business.wahllokalsystem.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.wahllokalsystem.entity.WahllokalsystemStatus;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractWahllokalsystemStatusEdit {

  @Inject
  protected WahllokalsystemStatusDAO dao;

  @Inject
  protected WahllokalsystemStatusExtendedDAO extendedDao;

  public void delete(WahllokalsystemStatus entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(WahllokalsystemStatus entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(WahllokalsystemStatus entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected WahllokalsystemStatus getAttachedEntity(WahllokalsystemStatus entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected WahllokalsystemStatus getAttachedAndRefreshedEntity(WahllokalsystemStatus entity) {
    return dao.refresh(entity);
  }
}
